LeetCode 2364.统计坏数对的数目

给你一个下标从 0 开始的整数数组 nums 。如果 i < j 且 j - i != numsj - numsi ,那么我们称 (i, j) 是一个 坏数对 。

请你返回 nums 中 坏数对 的总数目。

示例 1:

输入:nums = 4,1,3,3

输出:5

解释:数对 (0, 1) 是坏数对,因为 1 - 0 != 1 - 4 。

数对 (0, 2) 是坏数对,因为 2 - 0 != 3 - 4, 2 != -1 。

数对 (0, 3) 是坏数对,因为 3 - 0 != 3 - 4, 3 != -1 。

数对 (1, 2) 是坏数对,因为 2 - 1 != 3 - 1, 1 != 2 。

数对 (2, 3) 是坏数对,因为 3 - 2 != 3 - 3, 1 != 0 。

总共有 5 个坏数对,所以我们返回 5 。

示例 2:

输入:nums = 1,2,3,4,5

输出:0

解释:没有坏数对。

提示:

1 <= nums.length <= 10 5 ^5 5

1 <= numsi <= 10 9 ^9 9

把j - i != nums[j] - nums[i]变形为nums[i] - i != nums[j] - j,枚举nums,对于当前枚举的值的下标i,我们把numsi-i加入哈希表,然后看后面是否还存在j,使得nums[i] - i != nums[j] - j。获取哈希表中不相等的元素数量比较麻烦,可以获取哈希表中相等的元素数量,即好数对数量,然后用总的数对数减去好数对数量

cpp 复制代码
class Solution {
public:
    long long countBadPairs(vector<int>& nums) {
        int n = nums.size();
        long long ans = (long long)(n - 1) * n / 2;

        unordered_map<int, int> m;

        for (int i = 0; i < n; ++i) {
            int target = nums[i] - i;
            if (m.find(target) != m.end()) {
                ans -= m[target];
            }

            ++m[target];
        }

        return ans;
    }
};

如果nums的长度为n,则此算法时间复杂度为O(n),空间复杂度为O(n)。

相关推荐
m0_639906946 小时前
Redis入门|五种数据结构、使用场景、持久化RDB&AOF
数据结构·数据库·redis
ZhengEnCi7 小时前
Agent 架构怎么选:从单 Agent 到多 Agent 编排的选型决策指南
算法·架构
秋天的怀念_David8 小时前
第二十二夜 · 数字迷雾
java·程序人生·算法
Pniubi8 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展
hhb_6188 小时前
大模型落地三重优化实战
人工智能·算法·机器学习
云和数据.ChenGuang9 小时前
光哥说Python RAG 系统需要哪些评估指标:从检索到生成的全链路评测指南
网络·人工智能·python·算法·langchain
2601_9707038310 小时前
工业除湿机租赁:把一份租金合同拆开看
大数据·数据结构·算法·数据库架构·推荐算法
心中有你021410 小时前
Java实现Dijkstra最短路径算法(邻接表 + 优先队列)
java·数据库·算法
ZhengEnCi11 小时前
同样的模型,为什么本地和云 API 差别那么大:量化精度、聊天模板与采样参数的三大元凶
人工智能·算法·llm
Flynn Liang12 小时前
RAG 答非所问/幻觉怎么破?Spring AI QuestionAnswerAdvisor 召回优化实战(TopK/重排/混合检索)
人工智能·算法·spring·rag·幻觉·springai